%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Naheed Baksh
%   Student # 0458146
%   ELEC ENG 4BI6
%   The following code is a part of the  EE4BI6 - final year project 
%   HRandSPO2.m calculates the heart rate and oxygen saturation for one
%       cycle of the LEDs
%   inputs:
%       IR_in = infrared data for one cycle
%       R_in = red light data for one cycle
%       r_peak: input parameter for the peakdet function describing the comparison
%               critereon for the red signal
%       ir_peak: input parameter for the peakdet function describing the comparison
%               critereon for infrared signal
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function [HR_avg, SPO2, SPO2_avg] = HRandSPO2(IR_in, R_in,r_peak,ir_peak)

% clearing variable related to the input arrays
clear IR Red Red avg_IR avg_R;
% clearing variable related to peak detection
clear max_IR min_IR max_R min_R max_IR_adjust min_IR_adjust max_R_adjust min_R_adjust;  
% clearing variable related to HR computation
clear HR_R HR_IR HR_avg;
% clearing variable related to SPO2 computarion
clear Vmax_R Vmin_R Vmax_IR Vmin_IR;
clear L_max_R L_max_IR L_min_IR L_min_R;
clear R_index_R R_index_IR R_index R SPO2;
clear Vmin_R_cor Vmax_R_cor Vmin_IR_cor Vmax_IR_cor SPO2;


% get IR and R for one cycle 

IR = IR_in; 
Red = R_in;

t_step = 0:0.001:(length(IR)-1)/1000;

% detecting peak and plotting the segmented functions

[max_IR min_IR] = peakdet(IR, ir_peak);
figure;
subplot(2,1,1)
plot(IR);
hold on;
plot(max_IR(:,1), max_IR(:,2), 'g*');
plot(min_IR(:,1), min_IR(:,2), 'r*');

[max_R min_R] = peakdet(Red, r_peak);
subplot(2,1,2)
plot(Red);
hold on;
plot(max_R(:,1), max_R(:,2), 'g*');
plot(min_R(:,1), min_R(:,2), 'r*');


% convert the max and min times to seconds
    
    
max_R_adjust(:,1) = max_R(:,1)/1000;
max_R_adjust(:,2) = max_R(:,2);
min_R_adjust(:,1) = min_R(:,1)/1000;
min_R_adjust(:,2) = min_R(:,2);
max_IR_adjust(:,1) = max_IR(:,1)/1000;
max_IR_adjust(:,2) = max_IR(:,2);
min_IR_adjust(:,1) = min_IR(:,1)/1000;
min_IR_adjust(:,2) = min_IR(:,2);

% max_R_adjust etc are matrices that containes the highest and lowerst
% peaks and their occuring time in seconds 
% Heart rate can be calculated using this matrices
% Pleasenote that in this case we will only use the highest peaks to
% calculate the heart rate 
% Heart rate is in the units of beats per minute
  
size_R = size(max_R_adjust);
for i = 1:size_R(1)-1
    
HR_R(i) = 60/(max_R_adjust(i+1)- max_R_adjust(i));

end  
  

HR_avg = 0;

for index = 1:numel(HR_R)
    
HR_avg = HR_avg + HR_R(index);
end

HR_avg = HR_avg/length(HR_R);

% Calculating blood axygen saturation
% Step 1; Calculate R, see explanation in appendix B

Vmax_R = max_R_adjust(:,2);
Vmax_IR = max_IR_adjust(:,2);
Vmin_R = min_R_adjust(:,2);
Vmin_IR = min_IR_adjust(:,2);

L_max_R = length(Vmax_R);
L_max_IR = length(Vmax_IR);
L_min_R = length(Vmin_R);
L_min_IR = length(Vmin_IR);

if (L_max_R>L_min_R)
    R_index_R = L_min_R;
else 
    R_index_R = L_max_R;
end

if (L_max_IR>L_min_IR)
    R_index_IR = L_min_IR;
else 
    R_index_IR = L_max_IR;
end

if (R_index_IR > R_index_R)
    
    R_index = R_index_R;
else
    R_index = R_index_IR;
end

for x = 1:R_index
Vmin_R_cor(x) = Vmin_R(x);
Vmax_R_cor(x) = Vmax_R(x);
Vmin_IR_cor(x) = Vmin_IR(x);
Vmax_IR_cor(x) = Vmax_IR(x);

end

R = (log(Vmin_R_cor./Vmax_R_cor))./(log(Vmin_IR_cor./Vmax_IR_cor));

SPO2 = ((0.81 - 0.18*R)./(0.73 +0.11*R))*100;

SPO2_avg = 0; 

for calc_index = 1:length(SPO2)
    
    SPO2_avg = SPO2_avg + SPO2(calc_index);    
    
end

SPO2_avg = SPO2_avg/numel(SPO2);
    
end

