%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Naheed Baksh
%   Student # 0458146
%   ELEC ENG 4BI6
%   The following code is a part of the  EE4BI6 - final year project 
%   The code approx_apnea.m simulates a test procedure by using the data
%     obtained in the lab and by adding apnea attack like result in the
%     SaO2 timeseries
%   Based on the approxmate entropy analysis it produces 2 message boxes
%   Message box1: shows APEN
%   Message box2: shows Risk factor
%   input: SAO2 (the time series obtained in the lab)
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


function  approx_apnea( SAO2 )

%the following for loop repeats the data 100 times to produce a longerset of data

x = length(SAO2);
SAO2_apnea = zeros(1,x*100); 
for i = 1:100
    for index = 1:x
    SAO2_apnea(((i-1)*x)+index) =SAO2(index); 
    end
end

% Reducing each element of the time series by a random number from 1 to 6
% to create noise so that the data resembles an apnea situation

for rand_index = 1:length(SAO2_apnea)

SAO2_apnea(rand_index) = SAO2_apnea(rand_index) - (1 + (6-1).*rand(1,1));

end

% creating dips so that the data resembles an apnea situation 

for t = 1:10
SAO2_apnea((100*x+t-100))=55 + (60-55).*rand(1,1);
SAO2_apnea((100*x+t-100)+10)=62 + (70-62).*rand(1,1);
SAO2_apnea((100*x+t-100)+20)=70 + (75-70).*rand(1,1);
SAO2_apnea((100*x+t-100)+30)=75 + (80-75).*rand(1,1);
SAO2_apnea((100*x+t-100)+40)=70 + (75-70).*rand(1,1);
SAO2_apnea((100*x+t-100)+50)=78 + (90-78).*rand(1,1);
end

for t = 1:6
SAO2_apnea((100*x)/4+t)=60 + (65-60).*rand(1,1);
SAO2_apnea((100*x)/4+t+6)=65 + (75-65).*rand(1,1);
SAO2_apnea((100*x)/4+t+12)=70 + (77-70).*rand(1,1);
SAO2_apnea((100*x)/4+t+18)=75 + (80-75).*rand(1,1);
SAO2_apnea((100*x)/4+t+24)=75 + (85-75).*rand(1,1);
SAO2_apnea((100*x)/4+t+30)=75 + (88-75).*rand(1,1);
SAO2_apnea((100*x)/4+t+36)=89 + (90-89).*rand(1,1);

end

for t = 1:4
SAO2_apnea((100*x)/2+t)=60 + (65-60).*rand(1,1);
SAO2_apnea((100*x)/2+t+4)=60 + (70-60).*rand(1,1);
SAO2_apnea((100*x)/2+t+8)=60 + (70-60).*rand(1,1);
SAO2_apnea((100*x)/2+t+12)=72 + (85-72).*rand(1,1);
SAO2_apnea((100*x)/2+t+16)=75 + (90-75).*rand(1,1);
SAO2_apnea((100*x)/2+t+20)=70 + (90-70).*rand(1,1);
SAO2_apnea((100*x)/2+t+24)=73 + (88-73).*rand(1,1);

end


% plotting the data to see the mock sleep apnea sleep study result

len = length(SAO2_apnea);
t_1 = 0:10/60:(len-1)*10/60; 
figure; 
plot(t_1,SAO2_apnea)
axis([0 length(t_1)*10/60 0 100])
ylabel('SaO2 (%)');
xlabel('time, minutes');

% calculating approximate entropy of the new series
ApEn_apnea = APEN(SAO2_apnea,1);

% creating message box containing approximate entropy

APEN_apnea_str = num2str(ApEn_apnea);
APEN_apnea_str = strcat('Approximate Entropy = ',APEN_apnea_str);
msgbox(APEN_apnea_str, 'ApEn'); 

% creating message box containing appropriate warning based on ApEn

if (ApEn_apnea>=0.8)
    msgbox('High Risk', 'Warning')
elseif (ApEn_apnea<0.8 && ApEn_apnea>0.65)
    msgbox('Low Risk', 'Warning')
else 
    msgbox('Normal','Result')
        
end

end
