%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Naheed Baksh
%   Student # 0458146
%   ELEC ENG 4BI6
%   The following code is a part of the  EE4BI6 - final year project 
%   main.m 
%       - separates each cycle and then each cycle into  IR and R 
%       - calculates SaO2 and HR for each data set
%       - Shows result for a OSA positive and OSA negative case 
%   inputs:
%       data: data read from the text file obtained from labview   
%       freq: frequency of the square pulse, eg. 100mHz, freq = 0.1
%       m: input parameter for the approximate entropy function 
%       r_peak: input parameter for the peakdet function describing the comparison
%               critereon for the red signal
%       ir_peak: input parameter for the peakdet function describing the comparison
%               critereon for infrared signal
%   assumption, sampling rate is always 1k
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

function main(data, freq,m, r_peak, ir_peak)
close all;

size_data = length(data);

% plotting the raw data

t = 0:(1/1000): (size_data-1)/1000;
figure;
plot(t,data);
title('Data collected from Vout of the circuit');
xlabel ('time (s)');
ylabel ('Voltage from Vout, (V)');


% the following for loop locates the starting point of the first complete
% cycle starting with the red response

numcycles = floor(size_data*freq/1000)-1; % numcycles = # of workable cycles

for i = 1:size_data-500
comp = data(i) - data(i+50);
if (comp > 2)
    time = i; % the variable time will return the location in the data array where the first cycle begins
    break;
end
end

% the following for loop will isolate the useful portion of the array data
% to another array named data_revised

for i_revised = 1: numcycles*1000/freq
    
        data_revised (i_revised) = data (i_revised + time + 50);

end


% plotting the revised data
figure;
t_revised = 0:(1/1000):(numel(data_revised)-1)/1000;

plot(t_revised,data_revised);
title('Revised Data (only contains complete pulses)');
xlabel ('time (s)');
ylabel ('Voltage, (V)');


%%%%%%%%%%%%%%%%%%%%%%%%%
%Separate two signals 
%Each row of R and IR represents one set of data
%%%%%%%%%%%%%%%%%%%%%%%%%

RED = zeros(numcycles, 5000);
IR = zeros(numcycles, 5000);
RED_adjust = zeros(numcycles, 4500);
IR_adjust = zeros(numcycles, 4500);

for index = 1:numcycles

k = (index-1)*10000;    
RED(index,:) = data_revised (k+1:k+5000);
    for i = 1:4500
        RED_adjust(index,i) = RED(index,i+100); 
    end


IR(index,:) = data_revised (k+5001:k+10000);
    for i = 1:4500
        IR_adjust(index,i) = IR(index,i+100);
    end

% normalizing IR data

mean_set = mean(IR_adjust(index,:)) - mean(RED_adjust(index,:));
IR_adjust(index,:) = IR_adjust(index,:)-mean_set;

% calculating HR, SaO2 and average SaO2

[HR, SPO2,SPO2_avg]=HRandSPO2(IR_adjust(index,:), RED_adjust(index,:),r_peak, ir_peak);
HR_out(index) = HR;
SPO2_avg_out(index) = SPO2_avg;
end

% providing message box with average heart rate

HR_avg = mean(HR_out);
HR = num2str(HR_avg);
HR = strcat(HR,' beats per minute');
msgbox(HR, 'Average heart rate overnight')

% approximate entropy of the given dataset

ApEn =  APEN(SPO2_avg_out,m);

% plotting obtained SaO2 vs. time

figure; 
plot(SPO2_avg_out)

axis([0 length(SPO2_avg_out) 0 100]);
title('SpO2 of the obtained dataset');

% showing the SaO2 time series on MATLAB window

SPO2_avg_out

% showing results for OSA negative and OSA positive type sleep study
approx(SPO2_avg_out);
approx_apnea(SPO2_avg_out);

end